
# Functions to adapt bumphunter output that would return a confidence intervals. 

# going to be prepareBump()

prepareBump = function(index, bump_struct, groupsvec, meth_data ,margin = 1) {
  bs = bump_struct$table[index,"indexStart"]
  be = bump_struct$table[index,"indexEnd"]

  sbs = bs-margin  # With margin
  sbe = be+margin

  bump_measurements = t(meth_data[sbs:sbe,])

  condZ = bump_struct$coef[sbs:sbe]
  thresh= bump_struct$algorithm$cutoff

# Check that bump is one-directional
  stopifnot(all(condZ[(margin+1) : (margin + 1 + be - bs)] > 0 )| all(condZ[(1+margin) : (1 + margin + be - bs)] < 0 ))
  if (condZ[1+margin]> 0) { 
    direction = 1
  } else {
    direction = -1 
  }
  
  conditioning = c(rep(-1,margin), rep(1,be - bs + 1), rep(-1,margin))
  
  for (k in which(conditioning==-1)){
    if (condZ[k]*direction > thresh){
      conditioning[k]=0
#      warning('No conditioning')
    }
  }
  
  
  bump_dat = list(condY = bump_measurements, groups = groupsvec,thresh = thresh,margin = margin, direction = direction, condZ = condZ,
                  bs = bs,be = be,sbs = sbs, sbe = sbe, L = 1+ be - bs, conditioning = conditioning)

  return (bump_dat)
}


